<?php
/*------------------------------------------------------------------------
# copyright Copyright (C) 2010 virtuemart. All Rights Reserved.
-------------------------------------------------------------------------*/



// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
error_reporting('E_ALL');
error_reporting( 'E_ERROR');

jimport( 'joomla.plugin.plugin' );

class plgSystemVm_Search_Ac extends JPlugin
{
	var $isVM1 = false;

	function plgSystemVm_Search_Ac( &$subject, $config ) {
		parent::__construct( $subject, $config );

		$lang	=& JFactory::getLanguage();
		$lang->load('vm_search_ac',JPATH_ADMINISTRATOR);

		//Load only in front end
		$app = JFactory::getApplication();
		if ($app->isAdmin()) {
			return false;
		}
		
		if (JFile::exists(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_virtuemart'.DS.'version.php' )) { 
			include_once (JPATH_ADMINISTRATOR.DS.'components'.DS.'com_virtuemart'.DS.'version.php' );
			$VMVERSION = new vmVersion();
			if (isset($VMVERSION->RELEASE)) {
				$version = $VMVERSION->RELEASE;
			} else {
				$version = vmVersion::$RELEASE;
			}

			if (version_compare($version,'2.0.0','<')) {
				$this->isVM1 = true;
			} else {
				$this->isVM1 = false;
			}
		} else {
			//Virtuemart not found
			return false;
		}

	}

	function onAfterInitialise() {
		
		jimport('joomla.filesystem.file');
		$application = JFactory::getApplication();
		$option		= JRequest::getCmd('option');
		$ac	= JRequest::getVar('ac',0);
		$searchsku	= JRequest::getVar('searchsku',1);
		$searchchilds	= JRequest::getVar('searchchilds',1);
		$loadmj	= JRequest::getVar('loadmj',0);
		if (defined("_MJ") && !$loadmj) {
			return false;
		}
		
		if($option != 'com_virtuemart' || !$ac )	{
			return;
		}
		$q	= JRequest::getVar('q');
		$params = $this->params;
		$limit = $params->get( 'limit', 10 );
		$generate_sef = $params->get( 'generate_sef', 1 );
		

		if($this->isVM1) {
			//Virtuemart 1.1.x
			require_once( JPATH_SITE.'/components/com_virtuemart/virtuemart_parser.php' );
			global $sess, $mm_action_url;
			require_once(CLASSPATH.'ps_product.php');
			$ps_product = new ps_product;
			require_once(CLASSPATH.'ps_product_category.php');
			$ps_product_category = new ps_product_category;
			$db	=& JFactory::getDBO();
			$query = "SELECT Distinct product_id,product_name, product_sku, product_parent_id, product_thumb_image, '".IMAGEURL."product/' as product_thumb_path FROM #__{vm}_product ";
			$query .= " WHERE product_publish='Y'";
			if( $q ) {
				$query .= ' AND (product_name LIKE \'%'.$q.'%\'';
				if ($searchsku) {
					$query .= ' OR product_sku LIKE \'%'.$q.'%\'';
				}
				$query .= ')';
				if (!$searchchilds) {
					$query .= ' AND product_parent_id = 0';
				}
			}
			$query .= ' ORDER BY product_name, product_sku';
			$query .= ' LIMIT 0, '.($limit) ? $limit : 10;
			$query = str_replace("{vm}",VM_TABLEPREFIX,$query);
			$db->setQuery($query);
			$products = $db->loadObjectList();

			$result = array();
			foreach ($products as $product) {
				$item = new stdClass;
				$item->product_name = $product->product_name;
				$item->product_sku = $product->product_sku;
				$item->product_thumb_image = $product->product_thumb_image;
				$item->product_thumb_path = IMAGEURL.'product/';
				$cid = $ps_product_category->get_cid( $product->product_id );
				if ($product->product_parent_id) {
					$url = "index.php?option=com_virtuemart&page=shop.product_details&category_id=$cid&flypage=".$ps_product->get_flypage($product->product_parent_id);
					$url .= "&product_id=" . $product->product_parent_id;
				} else {
					$url = "index.php?option=com_virtuemart&page=shop.product_details&category_id=$cid&flypage=".$ps_product->get_flypage($product->product_id);
					$url .= "&product_id=" . $product->product_id;
				}
				if ($generate_sef) {
					$item->link = $sess->url($url);
				} else {
					$item->link = $mm_action_url. $url;
				}
				$result[] = $item;
			}

		} else {
			if(!isset($_GET['type_script'])){
				
				//Virtuemart 2.0
				if (!class_exists( 'VmConfig' )) require(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_virtuemart'.DS.'helpers'.DS.'config.php');
				VmConfig::loadConfig();
	
				if (!class_exists( 'VirtueMartModelProduct' )){
				   JLoader::import( 'product', JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_virtuemart' . DS . 'models' );
				}
				$productModel = new VirtueMartModelProduct();
				$productModel->setKeyWord($q);
				$valid_search_fields = array('product_name');
				if ($searchsku) {
					$valid_search_fields[] = 'product_sku';
				}
				$productModel->valid_search_fields 	= $valid_search_fields;
				$products = $productModel->getProductListing(false, $limit, false, false, false,false);
				$productModel->addImages($products);
	
				$result = array();
				foreach ($products as $product) {
					if (!$searchchilds && $product->product_parent_id > 0) {
						continue;
					}
					$item = new stdClass;
					$item->product_name = $product->product_name;
					$item->product_sku = $product->product_sku;
					if (!empty($product->images[0]->file_url_thumb) ) {
						$item->product_thumb_image = $product->images[0]->file_url_thumb;
					} else {
						$item->product_thumb_image = '/images/stories/virtuemart/noimage.gif';
					}
					$item->product_thumb_path = JURI::root();
					$item->link = $product->link;
					$result[] = $item;
				}
			}

		}

		@ob_end_clean(); // clear output buffer
		if ($result) {
			echo json_encode($result);
		}
		else return "";
		die();

	}
		

	/**
	 * Do something onAfterDispatch 
	 */
	function onAfterDispatch() {
		$loadmj	= JRequest::getVar('loadmj',0);
		if (defined("_MJ") && !$loadmj) {
			return false;
		}
		$this->_implementJavascript();
	}
	
	function _implementJavascript() {
		// if Admin side, just exit
		$application = JFactory::getApplication();
		if ($application->isAdmin()) { 
			return;
		}
		
		if(version_compare(JVERSION,'1.6.0','ge')) {
			$assets_path = 'plugins/system/vm_search_ac/vm_search_ac/';
		// Joomla! 1.6 and later code here
		} else {
			$assets_path = 'plugins/system/vm_search_ac/';
		// Joomla! 1.5 code here
		}
			
		if($this->isVM1) {
			require_once( JPATH_SITE.'/components/com_virtuemart/virtuemart_parser.php' );
		}

		//$plugin =& JPluginHelper::getPlugin( 'system', 'vm_search_ac' );
		$params = $this->params;
		$limit = $params->get( 'limit', 10 );
		
		if ($params->get( 'loadjquery', 1 )) {
			JHTML::script( 'jquery-1.7.1.min.js', $assets_path );
		}
		
		if ($cssfile = $params->get( 'cssfile', 'jquery.ac.css' )) {
			JHTML::stylesheet( $cssfile, $assets_path );
		}
		
		$js = "
		jQuery().ready(function() {
			var options = {
				dataType: 'json',
				parse: function(data) {return jQuery.map(data, function(row) {return {data: row,value: row.product_name,result: row.product_name}});},
				minChars:".$params->get( 'minChars', 3 ).",
				delay:".$params->get( 'delay', 400 ).",
				selectFirst:false,
				max: ".$params->get( 'max', 5 ).",
				resultsClass: 'ac_result',
				width:".$params->get( 'width', '200' ).",
				scrollHeight:false,
				formatItem: function(row) {var item='';";
					if ($params->get( 'showimg', 1 )) {
						$js.=" item+='<span class=\"product_img\"><img src=\"'+ row.product_thumb_path + row.product_thumb_image + '\"/></span> ';";
					}
					$js.="item+=row.product_name;";
					if ($params->get( 'showsku', 1 )) {
						$js.="item+='<br/><span class=\"product_sku\">'+row.product_sku+'</span>';";
					}
					$js.="return item;},
				extraParams:{ac:1,option:'com_virtuemart',view:'virtuemart',searchcat:".$params->get( 'searchcat', 1 ).",searchmanuf:".$params->get( 'searchmanuf', 1 ).",searchsku:".$params->get( 'searchsku', 1 ).",searchchilds:".$params->get( 'searchchilds', 1 )."}
			};
			fresult = function(event, data, formatted){if (data.link) {document.location.href = data.link;}}
			jQuery('.ac_vm[name=\"keyword\"],.ac_vm[type=\"text\"]').autocomplete('index.php',options).result(fresult);

		});";

		$document = &JFactory::getDocument();
		$document->addScriptDeclaration($js );

	}
}
